/* MAIN PROGRAM FOR WORD GENERATOR

     list of all dependency file     

suffix.c          / suffix(),delete_from_end() /
my_bsrch.c        / my_bsearch()  / 
trim.             / modify_prefix(),modify_star_suffix(),shift_right() /
strcp.c           / strcpy_till() /
RaR.c	          / RaR_list[] : pronoun_RAR /
form_wor.c	  / void form_word() /
ya_form.c	  / verb_yA_list[] : verb_correction /
get_prdtbl_entry.c	     / get_tabl_entry_no()  /
			     / connect_vibhakti() /
		             / generate_delete_file() /
subj.c            / verb_subj_list[] : verb_correction /
future.c          / verb_future_list[] : verb_correction /
parad.c		  / parad_tbl_entry[] : parad_tbl /	
n_excp.c	  / dict_parad_list[] : dict_entry /
nou_utils.c	  / Noun generator /
pro_utils.c	  / Pronoun generator /
verb_utils.c	  / Verb generator /
adj_utils.c	  / Adjective generator /
word_gen.c        / WORD GENERATOR /
fix.c             / prefix & suffix finding funct. /
exption.c         / exceptinol handling function . /
function.c

     list of header file used in above files

all_purpose.h     / For various definition /
gen.h             / Definition of  following structures/
	          / noun_paradigms, lex, verb_paradigms/
		  /  pronoun_paradogms ,shashti_paradigms /
mydefs.h          / struct pronoun_RaR,verb_correction /
my_defs.h	  / struct dict_entry,parad_entry,parad_tbl /	

*/

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <search.h>
#include "tam.c"
#include "/home/bharathi/TESTKND/anusAraka/com/headers/all_purpose.h" 	/* For various definition */
#include "../headers/gen.h" 
		

/* Global varibles for different generator */

char category[SMALL];
char TAM[MEDIUM];
char gender[SMALL];
char number[SMALL];
char person[SMALL];
char COMMENT[MEDIUM];
int GNP_FLAG; /* flag to guess default GNP */
int SHOW_FLAG;/* flag to show GNP in result */
int EXCPTION;

int GEN_WORD_CNT; /* Generator word counter */
void strcpy_till();
int read_input();

char word_num_str[MEDIUM],map_wc[SMALL], root[VERY_LARGE];

main(argc,argv)
int argc;
char *argv[];
{
   
    char result[VERY_LARGE],prefix[VERY_LARGE],suffix[VERY_LARGE];
    char extra_root[VERY_LARGE],word_tag[VERY_LARGE],jun[VERY_LARGE];
    char root_front[VERY_LARGE],troot[VERY_LARGE],*fresult,*rtam;
    int GEN_WORD_CNT = 1,EXTRA_ROOT_FLAG = 0,NEXT_SENSE=0,i;
    int map_no,sense_no,B_FLAG,rlen;

     if(argc != 3) {
	fprintf(stderr,"Illegal Call to Generator\n");
	fprintf(stderr,"Usage : new_gen.out {ON/OFF} {SHOW/NOT}\n");
	exit(0);
     }
     /* if OFF then verb generator assume default GNP */
     /* if ON then GNP will be consider for generation */
     if(!strcmp(argv[1],"OFF"))    GNP_FLAG = 1;
      else    {GNP_FLAG = 0;
	       fresult = (char *)malloc(LARGE);
              }
     if(!strcmp(argv[2],"SHOW")) SHOW_FLAG = 1;
      else SHOW_FLAG = 0;

      while ( read_input() != ERROR) {
      /* initilisation of variables */
      strcpy(result,"");
      strcpy(prefix,"");
      strcpy(suffix,"");
      strcpy(word_tag,"");
      strcpy(root_front,"");
      strcpy(jun,"");
      strcpy(troot,"");
      B_FLAG = 0;
      EXCPTION = 0;
      trim_word(root);

      /* check for multiple meaning */
     if(map_wc[0]=='\0') { /*sanjil*/
         map_no = 0;sense_no = 0;
     }else
      sscanf(map_wc,"%d, %d",&map_no,&sense_no);
      if ( sense_no > 1 ) {
	 NEXT_SENSE = 1;
	   printf("[");
      }
      
      /* check for multiple root */
      if (index(root,'&')){
         strcpy_till(root,extra_root,root,'&'); 
	 rlen = strlen(root);
	 EXTRA_ROOT_FLAG = 1;
       }


      if( root[0] == '#')   /* Newline start */
         {if(GEN_WORD_CNT >1)
          printf(" ");
	 printf("<%d>",GEN_WORD_CNT++);
	}
     else {
	      if (!NEXT_SENSE) printf(" ");
	      /* check for root seprated by '_' */
	      if(index(root,'_'))
		 strcpy_till(root_front,root,root,'_');

              /* split prefix & suffix from TAM */
	      if(index(TAM,'+') || index(TAM,'~'))
		 prefix_suffix(TAM,prefix,suffix);

             /* exceptional word handling */
	      EXCPTION = exceptional(jun,root,TAM);
              if(index(TAM,'_') && !EXCPTION)
	      cooked_TAM_suff(suffix,TAM,suffix);

	      if(EXCPTION){ /* root is modified */
		      if(strcmp(prefix,""))
			 printf("%s_",prefix);
		      if(strcmp(root_front,""))
			 printf("%s_",root_front);
		printf("%s",jun);
              }


	     if(EXCPTION == 0) {
		     /* word generator */
             if(GNP_FLAG) /* here GNP_FLAG=1 specifies GNP OFF */
		      word_gen(result,root,category,gender,number,person,TAM,GNP_FLAG);
             else
	     {
	     if((rtam = ( char *)my_bsearch(TAM,tam_gnp_str_ar[0].tam,TOTAL_FVG_TAMS,sizeof(tam_gnp_str_ar[0]),strcmp)) != '\0')
	     	rtam = (char *)((int)rtam + MAX_CHR_IN_TAM_STR);
	/*Pointer rtam is incremented to point next field,which is the modified TAM */
             if(rtam != NULL && strcmp(rtam,"0"))
	     {
	     i=0;
             while(*rtam !='_' && *rtam !='\0'&& rtam != NULL)
                   TAM[i++]= *rtam++;
	     TAM[i]='\0';
		      word_gen(result,root,category,gender,number,person,TAM,GNP_FLAG);
	    strcpy(fresult,result);
            if(*rtam != '\0')
	    {
            rtam++;	
            while(*rtam !='\0')
	      {
	       strcat(fresult,"_");
	       i=0;
	       while(*rtam != '_')
	         troot[i++]=*rtam++;
	       troot[i]='\0';
	       i=0; rtam++;
	       while(*rtam != '_' && *rtam !='\0')
	         TAM[i++]= *rtam++;
	       TAM[i]='\0';
		      word_gen(result,troot,category,gender,number,person,TAM,GNP_FLAG);
	       strcat(fresult,result);
	       if(*rtam != '\0')
	         rtam++;
              }   
	   }
	   strcpy(result,fresult);
	   if(EXTRA_ROOT_FLAG)
	   	{
	   	for(i=0;i<rlen;i++)
		fresult++;
                }
           }
	   else 
		      word_gen(result,root,category,gender,number,person,TAM,GNP_FLAG);
	   }/* end else */
		      /* print word with all acces. */
		      if(strcmp(prefix,""))
			 printf("%s_",prefix);
		      if(strcmp(root_front,""))
			 printf("%s_",root_front);
		      printf("%s",result);    /* Generated Word */
		      if(strcmp(word_tag,""))
			 printf("_%s",word_tag);
		      if(strcmp(suffix,""))
			 printf("_%s",suffix);

		      /* print GNP values for the word */
		      if((SHOW_FLAG == 1) && (category[0] == 'v'))
			if( (strcmp(gender,"any") != 0) && (strcmp(number,"any") != 0) && (strcmp(person,"any") != 0))
			   printf("{%s,%s,%s}",gender,number,person);
               } 
              if(NEXT_SENSE == 1) {
		  printf("]");
		  NEXT_SENSE = 0;
              }

	      /* generate extra word */
              if ( EXTRA_ROOT_FLAG == 1) {
	                printf("[");
			EXTRA_ROOT_FLAG = 0;
			while(strcmp(extra_root,"")){
			  strcpy_till(root,extra_root,extra_root,'&');
		  if(GNP_FLAG)
		      word_gen(result,root,category,gender,number,person,TAM,GNP_FLAG);
                  else
		      strcpy(result,strcat(root,fresult));
			  if(B_FLAG == 1) 
			    printf("/%s",result);
			  else {
                                 if(strcmp(prefix,""))
                                        printf("%s_",prefix);
				  printf("%s",result);
				  B_FLAG = 1; 
			  }
		          if(strcmp(suffix,""))
				 printf("_%s",suffix);
			}
			printf("]");
	      }
	}
  } /*while*/
printf("\n");
}  /* main */

/*
* function to read input structure 
*/

int read_input()
{
    char EOR[SMALL]; /* End of Record */
    char c;
    char *c_ptr;

/* if(scanf("%s",map_wc) != EOF){ sanjil */
    if(scanf("%s", root) != EOF){
    scanf("%s",word_num_str);
    scanf("%s", category);
    scanf("%s", gender);
    scanf("%s", number);
    scanf("%s", person);
    scanf("%s", TAM);
    scanf("%s", COMMENT);
     if(!strcmp(COMMENT,"NW")) COMMENT[0]= '\0';
 GEN_WORD_CNT=1;

    scanf("%s", EOR);
    if( (c_ptr = index(TAM,'/')) != NULL ) {
	*c_ptr = '\0';
	*c_ptr++;
	}
    if (!strcmp(EOR,"NW")) return TRUE;
      else{
	/* skip till the end of line, then read the input */
	fprintf(stderr,"\n\t[%s] Error in mappings output - skipping a word\n",root);
	for(c=getc(stdin);(c!='\n'&&c!=EOF);c=getc(stdin));
	read_input();
      }
  }
 else return ERROR;
}

