/*
PURPOSE :To read the input of lwg and store it in a two dimensional
	 global array E[wrd][entry].
	 The structure of E is      
	struct word {
	char tam[MAX_CHR_IN_TAM];
	int cat;
	char root[MAX_CHR_IN_PRATIPADIK];
	int gender;
	int number;
	int number1;
	int person;
	int case_n; CHANGED FOR USING PRIME NUMBERS
        char parsrg[MAX_CHR_IN_PARSARG]
        };
*/
#include <stdio.h>
#include <string.h>
#include "/home/bharathi/TESTKND/anusAraka/com/lwg/prog/headers/defn.h"
#include "/home/bharathi/TESTKND/anusAraka/com/lwg/prog/headers/struct.h"
#include "/home/bharathi/TESTKND/anusAraka/com/lwg/prog/headers/glbl.h"

extern int VSMT;
extern FILE *fp_err;

/*
read_sent()
{
int i;
 char c;
 i = 0;
 if((c=getchar()) != '$') {ungetc(c,stdin);return;}
  while(1)
     {
      if(!(get_wrd(snt_wrds[i]))) break;
      i++;
     }
}
	
int get_wrd(s)
char *s;
{
	char c;
	while ((c=getchar()) && ( c==' ' || c=='\n'));
	*s++ = c;
	while ((c=getchar())!=EOF && c!='\n' && c!=' ')
		*s++ = c;
        if(c == '\n') return(0); {* To indicate  the end of a sentence *}
	*s = 0;
        return (1);
}
*/

void
read_str () {
	char flag[20],chr,cat_c,root_s[MAX_CHR_IN_PRATIPADIK];
  	char *pos_dollar; 
	int i,j,unknown_cat,empty_wrd;
	char gender[GENDER],number[NUMBER],person[PERSON],case_tmp[CASE_TMP],parsarg[MAX_CHR_IN_PARSARG],number1[NUMBER];
	char word_num[100];
	i=0;j=0;unknown_cat=0,empty_wrd=1;
	chr = 'a'; /* only initialization.to be modified */
	while(chr != '\0' && chr != '#'){
	init_str();
	getline(flag);
	     while(!strcmp(flag,"input_word"))
	     {
	     getline(word_num);
	     getline(flag);
	     while(strcmp(flag,"input_word") && (flag[0]!='\0') && (flag[0]!='#'))
	     {
              empty_wrd = 1;
	      unknown_cat =0;
	      cat_c=flag[0];
	      getline(root_s);
       /*
	 if(MORPH_OLD){
	     pos_dollar = index(root_s,'$');
	     *pos_dollar = '\0';
	     }
       */
             strcpy(E[i][j].word_num,word_num);
	     strcpy(E[i][j].root,root_s);
	     switch (cat_c) {
	     case 'v':
		     if(flag[1] == 'n')
		     {
		     E[i][j].cat = VERBAL_NOUN;
		     getline(gender);
		     getline(number);
		     getline(case_tmp);
                     getline(parsarg);
                     if(MORPH_OLD) {            
			switch(case_tmp[0]){
					case 'd':strcpy(case_tmp,"0");
						 break;
					case 'o':strcpy(case_tmp,"1");
						 break;
					   }
                             }
		     E[i][j].gender =conv_gen(gender[0]);
		     E[i][j].number = conv_num(number[0]);
		     E[i][j].case_n = conv_cas(case_tmp);
		     strcpy(E[i][j].parsrg , parsarg);
	     	     getline(E[i][j].tam);
		     }
		     else
		     {
	     	     getline(E[i][j].tam);
		     /*if(strcmp(E[i][j].tam , "nA")) TEMP_FIX */
		     	E[i][j].cat = PURE_VERB;
		     /*else E[i][j].cat = VERBAL_NOUN; TEMP_FIX */
		     getline(gender);
		     getline(number);
		     getline(person);
		     E[i][j].gender =conv_gen(gender[0]);
		     E[i][j].number = conv_num(number[0]);
		     E[i][j].person = conv_per(person);
		     }
		     break;
	     case 'n':
                     E[i][j].cat = PURE_NOUN;
		     getline(gender);
		     getline(number);
		     getline(case_tmp);
                     getline(parsarg);
                     if(MORPH_OLD) {            
			switch(case_tmp[0]){
					case 'd':strcpy(case_tmp,"0");
						 break;
					case 'o':strcpy(case_tmp,"1");
						 break;
					   }
                             }
		     E[i][j].gender =conv_gen(gender[0]);
		     E[i][j].number = conv_num(number[0]);
		     E[i][j].case_n = conv_cas(case_tmp);
		     strcpy(E[i][j].parsrg , parsarg);
		     break;
	     case 'p':
		     E[i][j].cat = PURE_PARSARG;
		     break;
             case 'a':
		     if(flag[1] == 'd') /* case of adjectives */
                      {
                      getline(gender);
                      getline(number);
                      getline(case_tmp);
                      getline(parsarg);
                     if(MORPH_OLD) {            
                      switch(case_tmp[0]){
                                    case 'd':strcpy(case_tmp,"0");
                                              break;
                                    case 'o': strcpy(case_tmp,"1");
                                               break;
                                     }
			}
                      E[i][j].gender = conv_gen(gender[0]);
                      E[i][j].number = conv_num(number[0]);
                      E[i][j].case_n = conv_cas(case_tmp);
		      strcpy(E[i][j].parsrg , parsarg);
                      }
                     else
                      {
                       if(!(strcmp(E[i][j].root,"jo")))
                         E[i][j].cat = PRON_ADJ;
                       else
                         E[i][j].cat = PURE_ADJECTIVE;
                      getline(gender);
                      getline(number);
                      getline(case_tmp);
                     if(MORPH_OLD) {            
                      switch(case_tmp[0]){
                                    case 'd':strcpy(case_tmp,"0");
                                              break;
                                    case 'o': strcpy(case_tmp,"1");
                                               break;
                                     }
			}
                      E[i][j].gender = conv_gen(gender[0]);
                      E[i][j].number = conv_num(number[0]);
                      E[i][j].case_n = conv_cas(case_tmp);
		      }
                      break;
             case 'A' :
		       E[i][j].cat = AVYAYA;
		       break;
             case 'D' :
		      E[i][j].cat = PURE_ADVERB;
                      getline(gender);
                      getline(number);
                      getline(case_tmp);
		      getline(parsarg);
                     if(MORPH_OLD) {            
                      switch(case_tmp[0]){
                                    case 'd':strcpy(case_tmp,"0");
                                              break;
                                    case 'o': strcpy(case_tmp,"1");
                                               break;
                                     }
			}
                      E[i][j].gender = conv_gen(gender[0]);
                      E[i][j].number = conv_num(number[0]);
                      E[i][j].case_n = conv_cas(case_tmp);
                      strcpy(E[i][j].parsrg , parsarg);
		      break;
             case 'r' : 
		      E[i][j].cat = REL_PRONOUN;
                      getline(gender);
                      getline(number);
                      getline(case_tmp);
		      getline(parsarg);
                     if(MORPH_OLD) {            
                      switch(case_tmp[0]){
                                    case 'd':strcpy(case_tmp,"0");
                                              break;
                                    case 'o': strcpy(case_tmp,"1");
                                               break;
                                     }
			}
                      E[i][j].gender = conv_gen(gender[0]);
                      E[i][j].number = conv_num(number[0]);
                      E[i][j].case_n = conv_cas(case_tmp);
                      strcpy(E[i][j].parsrg , parsarg);
		      break;
             case 'P' : 
		      E[i][j].cat = PRONOUN;
                      getline(gender);
                      getline(number);
                      getline(case_tmp);
		      getline(parsarg);
                     if(MORPH_OLD) {            
                      switch(case_tmp[0]){
                                    case 'd':strcpy(case_tmp,"0");
                                              break;
                                    case 'o': strcpy(case_tmp,"1");
                                               break;
                                     }
			}
                      E[i][j].gender = conv_gen(gender[0]);
                      E[i][j].number = conv_num(number[0]);
                      E[i][j].case_n = conv_cas(case_tmp);
                      strcpy(E[i][j].parsrg , parsarg);
		      break;
            case 's':
		     E[i][j].cat = RaRTI;
                     if(!strcpy(flag,"sh_P")) 
                     {
                      getline(person);
                      E[i][j].person = conv_per(person);
                      }
                      getline(number);
                      getline(gender);
                      getline(number1);
                      getline(case_tmp);
		      getline(parsarg);
                     if(MORPH_OLD) {            
                      switch(case_tmp[0]){
                                    case 'd':strcpy(case_tmp,"0");
                                              break;
                                    case 'o': strcpy(case_tmp,"1");
                                               break;
                                     }
			}
                      E[i][j].number = conv_num(number[0]);
                      E[i][j].gender = conv_gen(gender[0]);
                      E[i][j].number1 = conv_num(number1[0]);
                      E[i][j].case_n = conv_cas(case_tmp);
                      strcpy(E[i][j].parsrg , parsarg);
		      break;

	     default: {
			if(VSMT)
			{
			fprintf(fp_err,"The category %s has not been included\n",flag);
		        print_status(i);
			while(strcmp(flag,"input_word"))getline(flag);
			unknown_cat = 1;
		        E[i][j].cat = UNKNOWN_CAT;
	                }
         	      }
	     }
             if(!unknown_cat)
	     getline(flag);
	     j++;
	     if(j>=TOTAL_LEX_ENTRIES_PER_WORD) 
	     {
	     fprintf(stderr,"only %d lex entries allowed\n",TOTAL_LEX_ENTRIES_PER_WORD);
	     fprintf(stderr,"exitting ... \n");
	     exit(0);
	     }
	     }
	     if((empty_wrd) && (j==0))
             E[i][j].cat = EMPTY_WRD;
             empty_wrd = 1;
	     i++;j=0;
	     if(i>=TOTAL_WRDS_IN_A_SENT) 
	     {
	     fprintf(stderr,"only %d words in a sentence are  allowed\n",TOTAL_WRDS_IN_A_SENT);
	     fprintf(stderr,"exitting ... \n");
	     exit(0);
	     }
	     }
	     chr=flag[0];
	     }
	     ungetc(chr,stdin);
	     TOTAL_WRDS = i;
	     }
