if($ARGV[0] eq "h"){
printf("USAGE: perl sandhi_split.pl LANG RLS_FL <DBG>\n");
printf("LANG : KAN/TEL/BNG\n");
printf("RLS_FL : path of the rls fl\n");
printf("DBG : optional parameter : value : 1/0\n");
exit(0);
}
if($ARGV[0] eq "KAN"){
require ("/home/bharathi/TESTKND/anusAraka/kannada/sandhi/com/get_mo_ana.pl");
}
if($ARGV[0] eq "TEL"){
require ("/home/bharathi/TESTKND/anusAraka/telugu/sandhi/com/get_mo_ana.pl");
}
if($ARGV[0] eq "BNG_calita"){
require ("/home/bharathi/TESTKND/anusAraka/bengali/sandhi/com/get_mo_c_ana.pl");
}
if($ARGV[0] eq "BNG_sadhu"){
require ("/home/bharathi/TESTKND/anusAraka/bengali/sandhi/com/get_mo_s_ana.pl");
}
local($in,$ans);
$DEBUG = 0;
$DEBUG = $ARGV[2];
$FL = $ARGV[1];
#
#### READ THE TABLE OF RULES
#
open(RLS,"<$FL");
@rls = <RLS>;
close(RLS,"rls");
$size_of_rls = $#rls+1;
if($DEBUG) {
print "Read the table of Rules\n";
print "Total size_of_rls =",$#rls,"\n";
}
#
#### SPLIT DIFF FIELDS
#
for($i = 3;$i<$size_of_rls;$i++)
{
chop($rls[$i]);
($rl_no[$i-3],$pat[$i-3],$br_pt[$i-3],$lft_dlt[$i-3],$lft_add[$i-3],
$rt_dlt[$i-3],$rt_add[$i-3],$lft_mo_call[$i-3],$rt_mo_call[$i-3],$lft_cond[$i-3],$rt_cond[$i-3])
=split(/	/,$rls[$i]);
if($lft_add[$i-3] eq "0") { $lft_add[$i-3] = "";}
if($rt_add[$i-3] eq "0") { $rt_add[$i-3] = "";}
if($lft_cond[$i-3] eq "0") { $lft_cond[$i-3] = "";}
if($rt_cond[$i-3] eq "0") { $rt_cond[$i-3] = "";}
}
#
### MAIN FUNCTION STARTS
#
while($in = <STDIN>)
{
chop($in);
$ans = "";
$orig_word = $in;
$flag = 0;
for($i=0;($i<$size_of_rls-3) && (!$flag);$i++)
{
while(($in =~ m/($pat[$i])/g) && (!$flag))
{
if($DEBUG){
print "RL",$rl_no[$i]," Pattern ",$pat[$i]." Matched\n";
}
#print $`," ",$1," ",$',"\n";
$pat = $1;
$lft = $`.substr($pat,0,$br_pt[$i]);
$rt = substr($pat,$br_pt[$i]).$';
$lft_len = length($lft);
$lft = substr($lft,0,$lft_len-$lft_dlt[$i]).$lft_add[$i];
$rt = $rt_add[$i].substr($rt,$rt_dlt[$i]);
if($DEBUG){
print "lft = ",$lft,"\n";
print "rt = ",$rt,"\n";
}
#
#Call morph for left string
#
if($lft_mo_call[$i]){
$lft_ans = &get_mo_ana($lft);
chop($lft_ans);
if($lft_ans eq "") { 
if($DEBUG) { print "Morph failed for left word ",$lft,"\n";}
}
}
else { $lft_ans = $lft;}
if((($lft_cond[$i] ne "") && ($lft_ans =~ /$lft_cond[$i]/)) ||
 ($lft_cond[$i] eq "")){
if($DEBUG) { print "left cond ",$lft_cond[$i]," satisfied for rule $rl_no[$i]\n";}
#
#Call morph for right string
#
if($rt_mo_call[$i]){
$rt_ans = &get_mo_ana($rt);
if($rt_ans eq "") { 
if($DEBUG) { print "Morph failed for right word ",$rt,"\n";}
}
}
else{$rt_ans = $rt."\n";}
if((($rt_cond[$i] ne "") && ($rt_ans =~ /$rt_cond[$i]/)) ||
($rt_cond[$i] eq "")){
if($DEBUG) { print "right cond ",$rt_cond[$i]," satisfied for rule $rl_no[$i]\n";}
if(($lft_ans ne "") && ($rt_ans ne "\n")){
print $orig_word," ","RL(",$rl_no[$i],")",$lft,"+",$rt,":",$lft_ans,"+",$rt_ans;
$flag = 1;
}
}
else {
if($DEBUG) { print "rt cond ",$rt_cond[$i]," not satisfied for rule $rl_no[$i]\n";}
if($DEBUG) { print "rt morph answer ",$rt_ans,"\n";}
}
}
else {
if($DEBUG) { print "lft cond=",$lft_cond[$i],"=not satisfied for rule $rl_no[$i]\n";}
if($DEBUG) { print "lft morph answer ",$lft_ans,"\n";}
}
}
}
if($flag == 0){
print $orig_word,"\n";
}
}
