#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#ifdef GNU
#include <gdbm.h>
#else
#include <ndbm.h>
#endif

#ifdef GNU
extern GDBM_FILE db_story_wrds;
#else
extern DBM *db_story_wrds;
#endif

extern void split_rec();

srch_dbm(pre_ch,word,last_ch)
char word[100];
char pre_ch,last_ch;
{
char ans_str[1000],code[3],mng1[100],mng2[100],mng3[100],sp1[100],sp2[100];
char new_word[1000];
int len,i,start,last;
datum db_tag,db_out;

if(isalpha(pre_ch) && isalpha(word[0])) {
new_word[0] = pre_ch;new_word[1] = '\0';
strcat(new_word,word);
strcpy(word,new_word);
pre_ch = '\0';
}
len = strlen(word);
i=0;
while(isspace(word[i]) && i<len) i++; /* ignore all leading spaces */
start = i;
strncpy(sp1,word,start);
sp1[start] = '\0';
i++;
while(!isspace(word[i]) && i<len) i++; /* find the position of next white space */
last = i;
strncpy(ans_str,word+start,last-start);
ans_str[last-start] = '\0';
start = last;
while(isspace(word[i]) && i<len) i++; /* ignore all leading spaces */
last = i;
strncpy(sp2,word+start,last-start);
sp2[last-start] = '\0';

db_tag.dptr = ans_str;
db_tag.dsize = strlen(ans_str);

#ifdef GNU
db_out = gdbm_fetch(db_story_wrds,db_tag);
#else
db_out = dbm_fetch(db_story_wrds,db_tag);
#endif

if(db_out.dptr != '\0')
{
i=0;
strncpy(ans_str,db_out.dptr,db_out.dsize);
ans_str[db_out.dsize]='\0';
/*
printf("%s",ans_str);
*/
code[0] = '\0';
mng1[0] = '\0';
mng2[0] = '\0';
mng3[0] = '\0';
split_rec(ans_str,code,mng1,mng2,mng3);
if(!strcmp(code,"1")) prcs_rule1(pre_ch,last_ch,mng1,mng2,sp1,sp2);
else if(!strcmp(code,"2")) prcs_rule2(pre_ch,last_ch,mng1,mng2,mng3,sp1,sp2);
else if(!strcmp(code,"4")) prcs_rule4(pre_ch,last_ch,mng1,mng2,sp1,sp2);
else if(!strcmp(code,"5")) prcs_rule5(pre_ch,last_ch,mng1,sp1,sp2);
else printf("%c%sOUT_%s_OUT%s%c",pre_ch,sp1,ans_str,sp2,last_ch);
}
else printf("%c%s%s%s%c",pre_ch,sp1,ans_str,sp2,last_ch);
}
