# This module gives the list of noun_roots , verb_roots & tams of
# the words in given file.
# noun roots,verb roots, tams & avys are stored in NOUNS VERBS TAMS & AVY resp
#
# Usage : grep_rt_tam.sh <file_name>
#
# This is tested for telugu data.
# To use this for other languages, just replace 'moh.sh' by
# corresponding morph analyser.

moh.sh < $1 > tmp.mo
paste $1 tmp.mo > $1.mo
grep '@' $1.mo > AVY
grep -v '@' $1.mo > $1.rem
perl /home/bharathi/TESTKND/tools/src/misc/get_rt_tam.pl < $1.rem | sort > $1.rt_tam
sort -u $1.rt_tam > $1.rt_tams
grep '^N:' $1.rt_tams > NOUNS
grep '^V:' $1.rt_tams > VERBS
grep '^TAM:' $1.rt_tams > TAMS
#rm $1.rem $1.rt_tam $1.rt_tams tmp.mo
