#!/usr/bin/perl
# This program guesses the pdgm of a given word.
# Given a word, this program for all possible paradigms of this word,
#forms different forms, and searches for the words occuring in the 
#corpus. Then depending on the given allowed error, it decides which is
#the best possible paradigm for the given word, on the basis of diff
#forms occurring in the corpus.
#
# Usage : noun_pdgm.cmd corpus allowed error
# input is a word
require "/usr3/amba/tools/src/morph/noun_pdgm.pl";
$corpus = $ARGV[0];
$allwd_err = $ARGV[1];
while($in = <STDIN>)
{
chop($in);
($stats_pdgm,$heuri_pdgm) = split(/:/,&noun_pdgm($in,$corpus,$allwd_err));
#print $stats_pdgm,",",$heuri_pdgm,"\n";
if($stats_pdgm eq $heuri_pdgm) {
print "Pdgm for $in is $stats_pdgm\n";}
else{
print "Using Statistics :Pdgm for $in is $stats_pdgm\n";
print "Using Heuristics :Pdgm for $in is $heuri_pdgm\n";}
}
