WRD [A-Za-z_0-9][A-Za-z_0-9]*
NON_WRD [^A-Za-z_0-9]
SPACE [ \t]*
NON_SPACE [^ \t\n]
 char pre_ch, last_ch;
%%
OUT_{NON_SPACE}+_OUT { printf("%s",yytext);}
FRZ_{NON_SPACE}+_FRZ { printf("%s",yytext);}
@{NON_SPACE}+/{SPACE} { printf("%s",yytext);}
^{SPACE}{WRD}{SPACE}$	{ pre_ch = '\0';
                          last_ch = '\0';
                          srch_dbm(pre_ch,yytext,last_ch);
                        }
^{SPACE}{NON_WRD}{SPACE}$	{ ECHO;
                                  pre_ch = '\0';
                                  last_ch = '\0';
                                 }
^{SPACE}{WRD}{SPACE}.	{ pre_ch = '\0';
                          last_ch = yytext[yyleng-1];
			  srch_dbm(pre_ch,yytext,last_ch);
		 	}
                                  
^{SPACE}{NON_WRD}{SPACE}.	{ pre_ch = '\0';
                                  last_ch = yytext[yyleng-1]; 
                                  yytext[yyleng-1] = '\0';
                                  printf("%s",yytext);
                                 }
{SPACE}{WRD}{SPACE}.	{ pre_ch = last_ch;
                          last_ch = yytext[yyleng-1];
                          srch_dbm(pre_ch,yytext,last_ch);
                        }
{SPACE}{NON_WRD}{SPACE}.	{ pre_ch = last_ch;
                                  last_ch = yytext[yyleng-1]; 
                                  yytext[yyleng-1] = '\0';
                                  printf("%c%s",pre_ch,yytext);
                                 }
{SPACE}{WRD}{SPACE}$	{ pre_ch = last_ch;
                          last_ch = '\0';
                          srch_dbm(pre_ch,yytext,last_ch);
                         }
{SPACE}{NON_WRD}{SPACE}$	{ pre_ch = last_ch;
                                  last_ch = '\0';
                                  printf("%c%s",pre_ch,yytext);
                                 }
%%
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#ifdef GNU
#include <gdbm.h>
#else
#include <ndbm.h>
#endif

#ifdef GNU
void *my_fatal()
{
}
#endif

#ifdef GNU
GDBM_FILE db_story_wrds;
#else
DBM *db_story_wrds;
#endif

main(argc,argv)
int argc;
char *argv[];
{
#ifdef GNU
db_story_wrds = gdbm_open(argv[1],512,GDBM_READER,0644,my_fatal());
#else
db_story_wrds = dbm_open(argv[1],O_RDONLY,0644);
#endif

yylex();

#ifdef GNU
gdbm_close(db_story_wrds);
#else 
dbm_close(db_story_wrds);
#endif
}

