#!/usr/bin/perl
# If mail has arrived, chk whether it is for
# Marking UW, or
# running trigger

open(TMP,$ARGV[0]);
# READ Mail header

$msg = 0;
$sbj_flag = 0;
while(($in = <TMP>) && ($sbj_flag != 1))
{
#print $in;
if($in =~ /^From /) { $from_add = $in;}
if($in =~ /^Return Path/) { $ret_path = $in;}
if($in =~ /^Received/) { $recd = $in;}
if($in =~ /^Date:/) { $date = $in;}
if($in =~ /^From:/) { $from1 = $in;}
if($in =~ /^Message-ID:/) { $msg_id = $in;}
if($in =~ /^To:/) { $to = $in;}
if($in =~ /^Subject:/) { $subj = $in; $sbj_flag = 1;}
}

#Get from address
$from_add =~ s/^From //;
$from_add =~ s/ .*//;
$from_add =~ s/\n$/ /;
#print "FFFF",$from_add;

## Take the action in the subject
if($subj =~ /[mM][aA][rR][kK].*[uU][wW]/)
{
print STDERR " Marking UNKN wrds for the file sent by $from_add\n";
$subj = "Re: MARK_UW";
$action = "mo_d.sh < story ";
}
elsif($subj =~ /[tT][rR][iI][gG][gG][eE][rR][_\-][bB][hH][kK]/)
{
print STDERR " Running trigger on the file sent by $from_add\n";
$subj = "Re: TRIGGER_bhk";
$action = "trigger_bhk story ";
}
elsif($subj =~ /[kK][aA][nN][nN][aA][dD][aA]\-[hH][iI][nN][dD][iI]/)
{
print STDERR " Running kannada-hindi trigger on the file sent by $from_add\n";
$subj = "Re: KANNADA_HINDI";
$action = "anu_kan_d story ";
}
elsif($subj =~ /[tT][eE][lL][uU][gG][uU]\-[hH][iI][nN][dD][iI]/)
{
print STDERR " Running telugu-hindi trigger on the file sent by $from_add\n";
$subj = "Re: TELUGU_HINDI";
$action = "trigger_frz story ";
}
elsif($subj =~ /[tT][rR][iI][gG][eE][rR]/)
{
print STDERR " Running telugu-hindi trigger on the file sent by $from_add\n";
$subj = "Re: TRIGGER";
$action = "trigger_frz story ";
}

#Put the mail msg in file "story"
open(STORY,">story");
$in = <TMP>;
if($in =~ /Status:/) { $Status = $in;} else { print STORY $in; }
while($in = <TMP>)
{
print STORY $in;
}
$from = $in;
close(STORY);

#Process the 'story'

system("$action > story.out");
system("rm msg");

#Send the output back to the sender
$mail_rpl = "mailx ".$from_add."-s \"".$subj."\" < story.out\n";
open(HEAD,">mail_header");
print HEAD $mail_hdr;
close(HEAD);
#print $mail_rpl,"\n";
system("$mail_rpl");
