 char map[]="01234567890123456789012345678901234567890123456789012345678901234˹⼶ܻLQվVY      ʸ᷵ۺ׽͡ ";
%{
extern char buffer1[100];
extern char buffer[100];

#define YY_INPUT(buf,result,max_size) \
        { \
result = (buffer[0]=='\0') ? YY_NULL : (strcpy(buf,buffer),strlen(buffer));\
       buffer[0]='\0'; }
%}

NUKTA Z
OPERATOR_V V
OPERATOR_Y Y
SPECIAL_CATEGORY [zMH]
VOWEL_A a
VOWEL_REMAINING [AiIuUqeEoO]
CONSONANT [kKgGfcCjJFtTdDNwWxXnpPbBmyrlvSRsh]
ROM_WORD [A-Za-z0-9]+
%x CONS 
%%
@{ROM_WORD}				{sprintf(buffer1+strlen(buffer1),"%s",yytext+1);}

{CONSONANT}				{
					sprintf(buffer1+strlen(buffer1),"%c",map[yytext[0]]);BEGIN CONS;
					}

<CONS>{NUKTA}				{
					sprintf(buffer1+strlen(buffer1),"");
					}

<CONS>{VOWEL_A}				{BEGIN INITIAL;}

<CONS>{VOWEL_REMAINING}			{
					sprintf(buffer1+strlen(buffer1),"%c",map[yytext[0]]);
					BEGIN INITIAL;
					}

<CONS>{VOWEL_REMAINING}{OPERATOR_V}+ 	{
					sprintf(buffer1+strlen(buffer1),"%c",map[yytext[0]]-yyleng+1);
					BEGIN INITIAL;
					}

<CONS>{VOWEL_REMAINING}{OPERATOR_Y}+ 	{
					sprintf(buffer1+strlen(buffer1),"%c",map[yytext[0]]+yyleng-1);
					BEGIN INITIAL;
					}

<CONS>{CONSONANT}			{
					sprintf(buffer1+strlen(buffer1),"%c",map[yytext[0]]);
					}

<CONS>{CONSONANT}{OPERATOR_V}+		{
					sprintf(buffer1+strlen(buffer1),"%c",map[yytext[0]]-yyleng+1);
					}

<CONS>{CONSONANT}{OPERATOR_Y}+		{
					sprintf(buffer1+strlen(buffer1),"%c",map[yytext[0]]+yyleng-1);
					}

<CONS>(.|\n)				{
					sprintf(buffer1+strlen(buffer1),"%c",yytext[0]);
					BEGIN INITIAL;
					}

{VOWEL_REMAINING}			{
					sprintf(buffer1+strlen(buffer1),"%c",map[yytext[0]]-53);
					}

{VOWEL_A}				{
					sprintf(buffer1+strlen(buffer1),"%c",map[yytext[0]]);
					}

{SPECIAL_CATEGORY}			{
					sprintf(buffer1+strlen(buffer1),"%c",map[yytext[0]]);
					}

{CONSONANT}{OPERATOR_V}+		{
					sprintf(buffer1+strlen(buffer1),"%c",map[yytext[0]]-yyleng+1);
					BEGIN CONS;
					}

{CONSONANT}{OPERATOR_Y}+		{
					sprintf(buffer1+strlen(buffer1),"%c",map[yytext[0]]+yyleng-1);
					BEGIN CONS;
					}

{VOWEL_REMAINING}{OPERATOR_V}+		{
					sprintf(buffer1+strlen(buffer1),"%c",map[yytext[0]]-53-yyleng+1);
					}

{VOWEL_REMAINING}{OPERATOR_Y}+		{
					sprintf(buffer1+strlen(buffer1),"%c",map[yytext[0]]-53+yyleng-1);
					}


{VOWEL_A}{OPERATOR_V}+			{
					sprintf(buffer1+strlen(buffer1),"%c",map[yytext[0]]-yyleng+1);
					}

{VOWEL_A}{OPERATOR_Y}+			{
					sprintf(buffer1+strlen(buffer1),"%c",map[yytext[0]]+yyleng-1);
					}
.					{
					sprintf(buffer1+strlen(buffer1),"%c",yytext[0]);
					}
%%
riwrap(){
return 1;
}
