# This program prepares a frequency count for complete corpus.
# First directorywise files of freq count are created.
# All these freq count files are merged & freq_count for complete corpus 
# is prepared.

# NOTE : corpus exists on anu2
# Directory wise frequency count of words 

for i in `cat /home/corpus/ciil/dirs.all`
do
mkdir $i
echo $i
zcat /home/corpus/ciilorig/$i/*  | tr ' ' '\012' > jnk
mv jnk $i/words
/home/bharathi/TESTKND/tools/bin/frequency_count.out < $i/words > $i/words.f
rm $i/words
done

# Merge all the frequecny count files.

for i in `cat /home/corpus/ciil/dirs.all`
do
echo $i
sort -m +1 $i/words.f words.f > jnk
mv jnk words.f
done

# get the total frequency count file for complete corpus.

perl5.001 /home/bharathi/TESTKND/tools/src/stats/add_freq.pl < words.f > jnk
sed '1,$s/ [ ]*/ /' jnk > jnk1
rm jnk
sort -nr jnk1 > freq_count
rm jnk1
