require "/home/bharathi/TESTKND/tools/src/morph/add_suff_n_del_char.pl";
# this routine generates a paradigm for a given word,
# for this it first extracts the info about #of chars to be deleted & suff to
# be added to the word in order to form a new form of the word from the root.

sub gen_pdgm
{
local($word,$pdgm) = @_;
local($in,$root,$out_fl,@wrds,$wrd,$del,$suff,$frm,$len);
$len = length($word);
#print $len,"\n";
$pdgm_fl = "cn_".$pdgm.".p";
system("cp /home/bharathi/TESTKND/anusAraka/morph/pc_data/$pdgm_fl .");
open(PDGM,$pdgm_fl);
$out_fl = $word.".".$pdgm;
open(OUT,">$out_fl");
$in = <PDGM>; # eat the category
$root = <PDGM>; # get the root
chop($root);
while($in = <PDGM>)
{
chop($in);
@wrds = split(/\//,$in);
foreach $wrd (@wrds)
{
#print $wrd,"\n";
if($wrd ne "-") {
($del,$suff) = split(/,/,&add_suff_n_del_char($root,$wrd));
$frm = substr($word,0,$len-$del).$suff;
}
else { $frm = "-";}
print OUT $frm,"\n";
#print "del_suff ",$del,$suff,"\n";
#print "frm ",$frm,"\n";
}
}
close(PDGM);
close(OUT);
}
1;
