$vowel = "aeiouAEIOU";
$cons = "kctwpgjdxbKCTWPGJDXByrlvsSRhmnNY";
sub noun_pdgm_usr
{
local($in) = @_;
if($in =~ /a$/)
  {
   $ans = "kota";
  }
elsif($in =~ /[AIUeEoO]$/)
  {
   $ans = "rikRA";
  }
elsif($in =~ /eV$/)
  {
   $ans = "peVtteV";
  }
# oV ending words are not found in dict
elsif($in =~ /[aA]M$/)
  {
   $ans = "puswakaM";
  }
elsif($in =~ /uM$/)
  {
   $ans = "meku"; # hukuM-> hukumulu Present pdgm does not handle this.
  }
elsif($in =~ /eV?M$/)
  {
   $ans = "paMxeVM";
  }
# [iIUEoO]M ending words not found in dict
elsif($in =~ /pUvu$/)
  {
   $ans = "pUvu";
  }
elsif($in =~ /vu$/)
  {
   $ans = "meku";
  }
elsif($in =~ /ku$/)
  {
   $ans = "meku";
  }
elsif($in =~ /rAttu$/)
  {
   $ans = "meku";
  }
elsif($in =~ /ttu$/)
  {
   $ans = "koVttu";
  }
elsif($in =~ /Mtu$/)
  {
   $ans = "beVMdu";
  }
elsif($in =~ /[kcwpKCTWPgjdxbGJDXByrlvsSRhmNY]tu$/)
  {
   $ans = "meku";
  }
elsif($in =~ /[aeiouAEIOUV]tu$/)
  {
   $ans = "kotu";
  }
elsif($in =~ /llu$/)
  {
 $pl = $in;
$pl1 = $in;
$pl =~ s/llu$/llYu/;
$pl1 =~ s/llu$/Mdlu/;
print "Are $pl and $pl1 accepted plural forms of the given word(y/n)?";
$chc = <STDIN>;
chop($chc);
if($chc eq "y") { $ans = "illu";}
else { $ans = "meku";}
  }
elsif($in =~ /lu$/)
  {
   $ans = "velu";
  }
elsif($in =~ /nnu$/)
{
$pl = $in;
$pl1 = $in;
$pl =~ s/nnu$/llYu/;
$pl1 =~ s/nnu$/Mdlu/;
print "Are $pl and $pl1 accepted plural forms of the given word(y/n)?";
$chc = <STDIN>;
chop($chc);
if($chc eq "y") { $ans = "kannu";}
else { $ans = "meku";}
}
elsif($in =~ /nu$/)
{
$pl = $in;
$pl =~ s/nu$/nlu/;
print "Is $pl accepted plural form of the given word(y/n)?";
$chc = <STDIN>;
chop($chc);
if($chc eq "y") { $ans = "bonu";}
else
{
$pl = $in;
$pl =~ s/nu$/lu/;
print "Is $pl accepted plural form of the given word(y/n)?";
$chc = <STDIN>;
chop($chc);
if($chc eq "y") { $ans = "cenu";}
else { $ans = "meku";}
}
}
elsif($in =~ /rru$/)
 {
 $ans = "meku";
 }
elsif($in =~ /ru$/)
{
$pl = $in;
$pl =~ s/ru$/llYu/;
print "Is $pl accepted plural form of the given word(y/n)?";
$chc = <STDIN>;
chop($chc);
if($chc eq "n") { $ans = "nOkaru";}
else
{
$pl = $in;
$pl =~ s/ru$/ti/;
print "Is $pl accepted singular RaRTi form of the given word(y/n)?";
$chc = <STDIN>;
chop($chc);
if($chc eq "y") { $ans = "goru";}
else 
{
$pl = $in;
$pl =~ s/ru$/llYo/;
print "Is $pl accepted form of the given word(y/n)?";
$chc = <STDIN>;
chop($chc);
if($chc eq "y") { $ans = "Uru";}
else { $ans = "vexuru";}
}
}
}
elsif($in =~ /Mdu$/)
{
$pl = $in;
$pl =~ s/Mdu$/llYu/;
print "Is $pl accepted plural form of the given word(y/n)?";
$chc = <STDIN>;
chop($chc);
if($chc eq "y") { $ans = "guMdu";}
else { $ans = "beVMdu";}
}
elsif($in =~ /[kctwpKCTWPgjxbGJDXBylvsSRhYmNn]du$/)
{
$ans = "gaxi";
}
elsif($in =~ /ddu$/)
{
$ans = "guddu";
}
elsif($in =~ /[aeiouAEIOUV]du$/)
{
$pl = $in;
$pl =~ s/du$/llYu/;
print "Is $pl accepted plural form of the given word(y/n)?";
$chc = <STDIN>;
chop($chc);
if($chc eq "y") 
{
$pl = $in;
$pl1 = $in;
$pl =~ s/du$/di/;
$pl1 =~ s/du$/ni/;
print "Are $pl and $pl1 accepted plural forms of the given word(y/n)?";
$chc = <STDIN>;
chop($chc);
if($chc eq "y") { $ans = "pillavAdu";}
else { $ans = "gUdu";}
}
else
{
$pl = $in;
$pl =~ s/du$/ru/;
print "Is $pl accepted plural form of the given word(y/n)?";
$chc = <STDIN>;
chop($chc);
if($chc eq "y") { $ans = "bAludu";}
else 
{
$pl = $in;
$pl1 = $in;
$pl =~ s/du$/di/;
$pl1 =~ s/du$/ni/;
print "Are $pl and $pl1 accepted RaRTi forms of the given word(y/n)?";
$chc = <STDIN>;
chop($chc);
if($chc eq "y") { $ans = "snehiwudu";}
else { $ans = "guddu";}
}
}
}
elsif($in =~ /u$/)
  { 
   $ans = "meku";
  }
elsif($in =~ /Ni$/)
  {
   $ans = "rANi";
  }
elsif($in =~ /[$vowel]ni$/)
  {
   $ans = "pani";
  }
elsif($in =~ /[$cons]ni$/)
  {
   $ans = "gaxi";
  }
elsif($in =~ /tti$/)
  {
   $ans = "putti";
  }
elsif($in =~ /Mti$/)
  {
   $ans = "piMdi";
  }
elsif($in =~ /[$cons]ti$/)
  {
   $ans = "gaxi";
  }
elsif($in =~ /ti$/)
  {
   $ans = "koti";
  }
elsif($in =~ /[$cons]ri/)
 {
$ans = "gaxi";
 }
elsif($in =~ /ri$/)
{
$pl = $in;
$pl =~ s/ri$/llYu/;
print "Is $pl accepted plural form of the given word(y/n)?";
$chc = <STDIN>;
chop($chc);
if($chc eq "y") { $ans = "paMxiri";}
else
{
$pl = $in;
$pl =~ s/ri$/rulu/;
print "Is $pl accepted plural form of the given word(y/n)?";
$chc = <STDIN>;
chop($chc);
if($chc eq "y") { $ans = "giri";}
else 
{
$pl = $in;
$pl =~ s/ri$/rlu/;
print "Is $pl accepted form of the given word(y/n)?";
$chc = <STDIN>;
chop($chc);
if($chc eq "y") { $ans = "xAri";}
else { $ans = "rAwri";}
}
}
}
elsif($in =~ /yi$/)
{
$pl = $in;
$pl =~ s/yi$/llYu/;
print "Is $pl accepted plural form of the given word(y/n)?";
$chc = <STDIN>;
chop($chc);
if($chc eq "y") { $ans = "rAyi";}
else
{
$pl = $in;
$pl =~ s/yi$/lu/;
print "Is $pl accepted plural form of the given word(y/n)?";
$chc = <STDIN>;
chop($chc);
if($chc eq "y") { $ans = "veyi";}
else 
{
$pl = $in;
$pl =~ s/yi$/wulu/;
print "Is $pl accepted form of the given word(y/n)?";
$chc = <STDIN>;
chop($chc);
if($chc eq "y") { $ans = "goyi";}
else { $ans = "abbAyi";}
}
}
}
elsif($in =~ /[dl]li/)
 {
$ans = "gaxi";
 }
elsif($in =~ /peVlYli/)
 {
$ans = "rAwri";
 }
elsif($in =~ /lYli/)
 {
$ans = "gaxi";
 }
elsif($in =~ /li$/)
{
$pl = $in;
$pl =~ s/li$/llYu/;
print "Is $pl accepted plural form of the given word(y/n)?";
$chc = <STDIN>;
chop($chc);
if($chc eq "y") { $ans = "wiragali";}
else { $ans = "puli";}
}
elsif($in =~ /Mdi$/)
{
$pl = $in;
$pl =~ s/Mdi$/llYu/;
print "Is $pl accepted plural form of the given word(y/n)?";
$chc = <STDIN>;
chop($chc);
if($chc eq "y") { $ans = "baMdi";}
else { $ans = "piMdi";}
}
elsif($in =~ /ddi$/)
{ 
$ans = "buddi";
}
elsif($in =~ /[aeiouAEIOUV]di$/)
{
$ans = "gudi";
}
elsif($in =~ /i$/)
{
$ans = "gaxi";
}
# there are no words with [^aeiouAEIOUVMd]di]$.
}
$ans;
1;
